#include "CurrencylayerClient.h"


CurrencylayerClient::CurrencylayerClient() {

}

void CurrencylayerClient::getLastChannelItem() {
  JsonStreamingParser parser;
  parser.setListener(this);
  WiFiClient client;

  // http://api.thingspeak.com/channels/CHANNEL_ID/feeds.json?results=2&api_key=API_KEY
  const char host[] = "www.openallnet.org";
  String url = "/currency.json";

  const int httpPort = 80;
  if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
    return;
  }


  Serial.print("Requesting URL: ");
  Serial.println(url);

  // This will send the request to the server
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" +
               "Connection: close\r\n\r\n");

  int retryCounter = 0;
  while(!client.available()) {
    Serial.println(".");
    delay(1000);
    retryCounter++;
    if (retryCounter > 10) {
      return;
    }
  }

  int pos = 0;
  boolean isBody = false;
  char c;

  int size = 0;
  client.setNoDelay(false);
  while(client.connected()) {
    while((size = client.available()) > 0) {
      c = client.read();
      if (c == '{' || c == '[') {
        isBody = true;
      }
      if (isBody) {
        parser.parse(c);
      }
    }
  }
}

void CurrencylayerClient::whitespace(char c) {

}

void CurrencylayerClient::startDocument() {

}

void CurrencylayerClient::key(String key) {

    isHeader = false;
  
  currentKey = key;
}

void CurrencylayerClient::value(String value) {
   // Serial.println(currentKey +": " + value);

      for (int i = 1; i < 5; i++) {
        String fieldKey = "USDEUR";

        if (currentKey == fieldKey) {

            lastFields[i-1] = value;
            //Serial.println(i + " - " + fieldKey + ": " + value);
          

        }
      }


}


String CurrencylayerClient::getFieldLabel(int index) {
  return fieldLabels[index];
}

String CurrencylayerClient::getFieldValue(int index) {	
  return lastFields[index];
}

String CurrencylayerClient::getCreatedAt() {
  return createdAt;
}

void CurrencylayerClient::endArray() {

}

void CurrencylayerClient::endObject() {

}

void CurrencylayerClient::endDocument() {

}

void CurrencylayerClient::startArray() {

}

void CurrencylayerClient::startObject() {

}
